"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Config = void 0;
const autobind_decorator_1 = require("autobind-decorator");
const lodash_1 = require("lodash");
class Config {
    constructor(app) {
        this.name = '@roots/bud-babel';
        this.plugins = {};
        this.presets = {};
        this._app = () => app;
    }
    get app() {
        return this._app();
    }
    normalizeEntry(c) {
        return lodash_1.isString(c)
            ? [c, {}]
            : c;
    }
    setPlugin(plugin) {
        plugin = this.normalizeEntry(plugin);
        this.plugins = { ...this.plugins, [plugin[0]]: plugin };
        return this;
    }
    setPlugins(plugins) {
        plugins.map(this.setPlugin);
        return this;
    }
    setPreset(preset) {
        preset = this.normalizeEntry(preset);
        this.presets = {
            ...this.presets,
            [preset[0]]: preset,
        };
        return this;
    }
    setPresets(presets) {
        presets.map(this.setPreset);
        return this;
    }
    unsetPreset(preset) {
        !this.presets[preset]
            ? this.app.error(`${preset} not found`)
            : delete this.presets[preset];
        return this;
    }
    unsetPlugin(plugin) {
        !this.plugins[plugin]
            ? this.app.error(`${plugin} not found`)
            : delete this.plugins[plugin];
        return this;
    }
    setPluginOptions(plugin, options) {
        this.plugins[plugin] = [this.plugins[plugin][0], options];
        return this;
    }
    setPresetOptions(preset, options) {
        this.presets[preset] = [this.presets[preset][0], options];
        return this;
    }
}
__decorate([
    autobind_decorator_1.boundMethod
], Config.prototype, "normalizeEntry", null);
__decorate([
    autobind_decorator_1.boundMethod
], Config.prototype, "setPlugin", null);
__decorate([
    autobind_decorator_1.boundMethod
], Config.prototype, "setPlugins", null);
__decorate([
    autobind_decorator_1.boundMethod
], Config.prototype, "setPreset", null);
__decorate([
    autobind_decorator_1.boundMethod
], Config.prototype, "setPresets", null);
__decorate([
    autobind_decorator_1.boundMethod
], Config.prototype, "unsetPreset", null);
__decorate([
    autobind_decorator_1.boundMethod
], Config.prototype, "unsetPlugin", null);
__decorate([
    autobind_decorator_1.boundMethod
], Config.prototype, "setPluginOptions", null);
__decorate([
    autobind_decorator_1.boundMethod
], Config.prototype, "setPresetOptions", null);
exports.Config = Config;
//# sourceMappingURL=Config.js.map